SystemOrganization addCategory: #'Glamour-Test-Morphic'!

TestCase subclass: #GLMMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Test-Morphic'!

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 11/19/2009 11:31'!
expectedFailures
	^ #(testChildrenBlock testChildrenBlockTakesEntity testColumnBlockTakesEntity)! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/17/2009 07:39'!
repeatAssert: aBlock equals: aResult

	self assert: (self wait: 0.5 until: aBlock evaluatesTo: aResult)! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/17/2009 07:37'!
send: treeMorph mouseUpOnItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseUp
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: 7
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onItem: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 11/19/2009 11:24'!
testChildrenBlock

	| browser window check treeMorph mouseUp treeNodeMorph |
	browser := GLMFinder new.
	check := false.
	browser tree
		children: [:each | check := true. #()].
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self assert: treeMorph class = LazyMorphTreeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	window delete.
	self repeatAssert: [check] equals: true! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 11/19/2009 11:25'!
testChildrenBlockTakesEntity

	| browser receivedEntity window |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser tree
		children: [:each :entity | receivedEntity := entity. #()].
	window := browser openOn: ($a to: $d).
	window delete.
	self repeatAssert: [receivedEntity] equals: ($a to: $d).
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 11/19/2009 11:25'!
testColumnBlockTakesEntity

	| browser receivedEntity window |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser table
		column: 'Even' evaluated: [:each :entity | receivedEntity := entity. 'x'].
	window := browser openOn: (1 to: 5).
	window delete.
	self repeatAssert: [receivedEntity] equals: (1 to: 5).
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 11/19/2009 11:24'!
testSpawnFinder

	| browser window check |
	browser := GLMFinder new.
	window := browser openOn: ($a to: $d).
	window delete.
	self repeatAssert: [window submorphs last class] equals: GLMPaneScroller.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 11/19/2009 11:25'!
testSpawnTableLayoutBrowser

	| browser window check |
	browser := GLMTabulator new.
	window := browser openOn: ($a to: $d).
	window delete.
	self repeatAssert: [
		window submorphs last 
					submorphs last 
						submorphs last 
							submorphs last class] equals: LazyMorphTreeMorph.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 11/19/2009 11:31'!
testTreeSelection

	| browser window check treeMorph mouseUp treeNodeMorph |
	browser := GLMFinder new.
	check := false.
	browser tree
		children: [:each | check := true. #()].
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self assert: treeMorph class = LazyMorphTreeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	window delete.
	self assert: (browser panes first port: #selection) value = $a! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/13/2009 09:15'!
wait: maxWaitSeconds until: validateBlock evaluatesTo: expectedResult
	"Evaluate validateBlock until it returns expectedResult or 
maxWaitSeconds have passed,
	 pausing between evaluations.  Return the last result of validateBlock 
value"

	| startTime result |
	startTime := Time secondClock.
	[result := validateBlock value = expectedResult] whileFalse:
			[Time secondClock - startTime > maxWaitSeconds ifTrue: [^result].
			(Delay forMilliseconds: 50) wait].
	^ result
! !
